#!/bin/sh

KERNEL_VER=${1:0:3}
DRV_AARICH=aarich.o
SCE_KM_AARICH=/usr/share/kmodule-aarich/2.4.21-27.ELsmp/i686/${DRV_AARICH}
DST_KM_AARICH=/lib/modules/$1/kernel/drivers/scsi/${DRV_AARICH}

/bin/rm -f /lib/modules/$1/build

if [ -L /lib/modules/$1/source ]; then
    /bin/rm -f /lib/modules/$1/source
fi

if [ $KERNEL_VER == "2.6" ]; then
    DRV_AARICH=aarich.ko
    SCE_KM_AARICH=/usr/share/kmodule-aarich/2.6.9-22.ELsmp/i686/${DRV_AARICH}
    DST_KM_AARICH=/lib/modules/$1/kernel/drivers/scsi/${DRV_AARICH}
fi

# check IBM x306 - scsi driver (aarich.o)
if [ -f ${SCE_KM_AARICH} ]; then
    if [ ! -f ${DST_KM_AARICH} ]; then
        cp -a ${SCE_KM_AARICH} ${DST_KM_AARICH}
    fi
fi

if [ -f /boot/initrd-$1.img ]; then
  rm -f /boot/initrd-$1.img
fi
echo "creating initrd.img..." > /dev/stderr
mkinitrd /boot/initrd-$1.img $1

cd /boot
ln -s initrd-$1.img initrd.img

if [ -L /boot/initrd.img.old ]; then
    if [ -L /boot/initrd.old ]; then
	rm -f /boot/initrd.old
    fi
    ln -s initrd.img.old initrd.old
fi
cd -

if [ ! -f /etc/lilo.conf ]; then
    exit 0
fi

# create /etc/lilo.conf

if [ -L /boot/vmlinuz.old ]; then
    
    set +e
    grep "^image=/boot/vmlinuz.old" /etc/lilo.conf &> /dev/null 
    if [ 0 != "$?" ]; then
	# modify lilo.conf
        LILO_TMP=`mktemp /etc/tmp.XXXXXX` || exit 1
        cp /etc/lilo.conf $LILO_TMP

	echo "image=/boot/vmlinuz.old" >> $LILO_TMP
	echo "        label=PreOld_Kernel" >> $LILO_TMP
	if [ -L /boot/initrd.old ]; then
	    echo "        initrd=/boot/initrd.old" >> $LILO_TMP
	fi
	echo "        read-only" >> $LILO_TMP
	echo "        optional" >> $LILO_TMP
	root_device=`/bin/grep -m 1 "^[[:space:]]*root=" /etc/lilo.conf`
	echo "       "$root_device >> $LILO_TMP
	append_info=`/bin/grep -m 1 "^[[:space:]]*append=" /etc/lilo.conf`
	if [ 0 = "$?" ]; then
	    echo "       "$append_info >> $LILO_TMP
	fi

        if [ -f /etc/lilo.conf.old ]; then
            rm -f /etc/lilo.conf.old
        fi

        mv /etc/lilo.conf /etc/lilo.conf.old
        cp $LILO_TMP /etc/lilo.conf
        echo "modified lilo.conf." > /dev/stderr
        echo "lilo.conf before correction was saved as lilo.conf.old." > /dev/stderr

        rm -f $LILO_TMP
    fi
    set -e
fi

# Update LILO
echo "Executing LILO..." > /dev/stderr
/sbin/lilo

exit 0
